<template>
	<view class="container" :style="{paddingTop:navbarHeight+'px'}">
		<!-- 自定义返回 -->
		<header-back :systeminfo='systeminfo' :navbar-data='nvabarData' :headerBtnPosi ="headerBtnPosi" :isDelete="isDelete"></header-back>
		<view class="container-order">
			<view class="search-input">
				<template>
					<view class="gosearch-btn" @click="goSearch()">
						<text class="iconfont icon-iconfonticonfontsousuo1"></text>
						<text>美白/润肤</text>
					</view>
				</template>
			</view>
			<!--选项卡逻辑自己实现即可，此处未做处理-->
			<tui-tabs :tabs="tabs" 
					  :isFixed="scrollTop>=0" 
					  :currentTab="currentTab" 
					  selectedColor="$color-system" 
					  sliderBgColor="$color-system"
					  @change="change"
					  :marginTop="navbarHeight">
			</tui-tabs>
			<view  :class="{'tui-order-list':scrollTop >= 0}" class="clearfix">
				<!-- 空白页 -->
				<empty v-if="isEmpty" :typeIndex="currentTab" :navbarHeight="navbarHeight"></empty>
				<!-- 列表 -->
				<view v-else class="tui-order-content">
					<view  class="tui-order-item" v-for="(order,orderIndex) in orderData" :key="orderIndex" >
						<view class="order-title">
							<view class="order-title-t">
								<view class="order-title-num">订单号：{{order.orderNo}}</view>
								<view class="order-title-tip">{{orderStateExp(order.status)}}</view>
							</view>
							<view class="order-title-b">下单时间：{{order.orderTime}}</view>
						</view>
						<block v-for="(item,index) in order.shopOrderList" :key="index">
							<view class="goods-title">
								<view class="title-logo"><image :src="item.shopLogo" mode=""></image></view>
								<view class="title-text">{{item.shopName}}</view>
							</view>
							<view class="goods-item" v-for="(pros,prosIndex) in item.cmOrderProducts" :key="prosIndex" @click.stop="detail(order.orderID)">
								<view class="goods-pros-t">
									<view class="pros-img"><image :src="pros.productImage" alt="" /></view>
									<view class="pros-product">
										<view class="producttitle">{{pros.name}}</view>
										<view class="productspec">规格:{{pros.productUnit}}</view>
										<view class="productprice">
											<view class="price">
												<text>￥{{pros.price}}</text>
											</view>
											<view class="count">
												<text class="small">x</text>{{pros.num}}
											</view>
										</view>
									</view>	
								</view>
							</view>	
						</block>
						<view class="order-footer">
							<view class="order-footer-top" v-if="order.discountFee!=0">经理折扣：¥{{orderPriceToFixed(order.discountFee)}}</view>
							<view class="order-footer-bot">
								<view class="count">共{{order.productCount}}件商品</view>
								<view class="money">合计：¥{{orderPriceToFixed(order.payableAmount)}}</view>
							</view>
						</view>
						<!-- 底部button -->
						<order-button ref="orderButton" 
									  :status="order.status" 
									  :orderID="order.orderID" 
									  @buttonConfirm="handButtonConfirm">
						</order-button>
					</view>
					<!--加载loadding-->
					<tui-loadmore :visible="loadding" :index="3" type="black"></tui-loadmore>
					<tui-nomore :visible="!pullUpOn" bgcolor="#F7F7F7" :text='nomoreText'></tui-nomore>
					<!--加载loadding-->
				</view>
			</view>
		</view>
		<!-- 分享弹窗 -->
		<share-alert   v-if="isShareModal"
					   :orderID="btnoRderID" 
					   @shareConfirm ='onShareAppMessage'>
		</share-alert>
		<!-- 删除订单弹窗 -->
		<model-alert v-if="isShowDelModal"
					 :alertText='alertText'
					 @btnConfirm ='handOrderDetele'>
		</model-alert>
		<!-- 取消订单弹窗 -->
		<cancel-alert v-if="isCenceModal"
					 :cenceAlertText='cenceAlertText'
					 @cenceConfirm ='handCenceConfirm'>
		</cancel-alert>
		<!-- 透明模态层 -->
		<modal-layer v-if='isModalLayer'></modal-layer>
	</view>
</template>

<script>
	import headerBack from '@/components/cm-module/headerNavbar/header-back' 		 	 //自定义导航
	import tuiTabs from "@/components/tui-components/tui-tabs/tui-tabs"
	import tuiListCell from "@/components/tui-components/list-cell/list-cell"
	import tuiLoadmore from "@/components/tui-components/loadmore/loadmore"
	import tuiNomore from "@/components/tui-components/nomore/nomore"
	import orderButton from '@/components/cm-module/orderDetails/orderListButton'		 //按钮
	import modalLayer from "@/components/modal-layer"
	import empty from "@/components/empty";
	import shareAlert from '@/components/cm-module/modelAlert/shareAlert'			 //分享弹窗
	import modelAlert from '@/components/cm-module/modelAlert/modelAlert'			 //删除弹窗
	import cancelAlert from '@/components/cm-module/modelAlert/cancelAlert'		 //取消弹窗
	export default {
		components: {
			empty,
			tuiTabs,
			tuiListCell,
			tuiLoadmore,
			tuiNomore,
			orderButton,
			modalLayer,
			modelAlert,
			shareAlert,
			cancelAlert,
			headerBack
		},
		data() {
			return {
				userID:0,
				orderData: [],
				btnoRderID: 0, //点击按钮传入的的订单ID
				currentTab: 0,
				pageNum: 1,	  //页数
				pageSize: 10,  //条数
				scrollTop: 0,
				deteleType:'',
				skeletonShow: true,
				isEmpty: false,
				isDelete:false,
				isShareModal: false,//控制分享弹窗
				isCenceModal: false,//控制取消订单弹窗
				isShowDelModal: false,//控制删除订单弹窗
				isModalLayer: false,
				loadding: false,
				pullUpOn: true,
				hasNextPage: false,
				pullFlag: true,
				navbarHeight:'',
				alertText: '确认删除订单吗？',
				cenceAlertText: '确认取消该订单吗？',
				nomoreText: '上拉显示更多',
				tabs: [
					{name: "全部"},
					{name: "待付款"}, 
					{name: "待发货"}, 
					{name: "已发货"}, 
					{name: "退货/款"},
				],
				headerBtnPosi:	this.setHeaderBtnPosi(), //获取设备顶部胶囊高度
				systeminfo:  this.setSysteminfo(),		 //获取设备信息
				nvabarData: {							 //顶部自定义导航
					showCapsule: 1, // 是否显示左上角图标  1表示显示  0表示不显示
					title: '我的订单', // 导航栏 中间的标题
				}
			}
		},
		onLoad(option) {
			if(option.type ==='detele'){this.isDelete = true}
			this.currentTab = option.state
			this.getHeaderTopHeight()//设置自定义导航高度
		},
		methods: {
			getOrderDatainit(index){
				/**
				 * @订单初始化加载  仅加载第一页码
				 * @param：orderState(订单状态:0全部,1待付款,2待发货,3已发货,4退货款)
				 * @param：userID(用户ID)
				 * @param：index(页码数)
				 * @param：pageSize(每页条数)
				 * @param：organizeID(全局变量组织ID)
				 */ 
				// setTimeout(()=>{this.skeletonShow = false},1500)
				this.$api.getStorage().then((resolve) =>{
					this.userID = resolve.userID
					let param = {orderState:index,userID:this.userID,index:1,pageSize:this.pageSize,organizeID:this.userOrganizeID}
					this.$api.lodingGet('/order/myOrder',param,
						response => {
							if(response.code === '1'){
								let resData = response.data.results
								this.hasNextPage = response.data.hasNextPage;
								if(resData && resData.length > 0){
									this.isEmpty = false;
									this.orderData = [...resData];
								}else{
									this.isEmpty = true
								}
								if(this.hasNextPage){
									this.pullUpOn = false
									this.nomoreText = '上拉显示更多'
								}else{
									if(this.orderData.length < 2){
										this.pullUpOn = true
									}else{
										this.pullUpOn = false
										this.nomoreText = '已至底部'
									}
								}
							}else{
								this.$util.msg(response.msg,2000);
							}
						}
					)	
				})	
			}, 
			getOnReachBottomData(index){//上拉加载
				this.pageNum+=1
				let param = {orderState:index,userID:this.userID,index:this.pageNum,pageSize:this.pageSize,organizeID:this.userOrganizeID}
				this.$api.get('/order/myOrder',param,
					response => {
						if(response.code === '1'){
							let resData = response.data.results
							this.hasNextPage = response.data.hasNextPage;
							this.orderData = this.orderData.concat(resData)
							this.pullFlag = false;// 防上拉暴滑
							setTimeout(()=>{this.pullFlag = true;},500)
							if(this.hasNextPage){
								this.pullUpOn = false
								this.nomoreText = '上拉显示更多'
							}else{
								this.loadding = false
								this.pullUpOn = false
								this.nomoreText = '已至底部'
							}
						}else{
							this.$util.msg(response.msg,2000);
						}
					}
				)	
			},
			change(e) {//切换tab传递当前tab[index]执行初始化方法
				this.currentTab = e.index
				this.pageNum = 1
				this.orderData = []
				this.pullUpOn = true //切换时隐藏
				this.loadding =  false //切换时隐藏
				this.getOrderDatainit(this.currentTab)
			},
			detail(id) {//订单详情跳转
				this.isModalLayer = true;	
				this.$api.navigateTo(`/pages/user/order/order-details?state=${this.currentTab}&orderID=${id}`)
			},
			handButtonConfirm(data) {//获取点击
				this.handShowAlert(data)
				this.btnoRderID = data.orderId
			},
			handShowAlert(data) {//执行
				switch(data.type){
					case 'delete':
						this.isShowDelModal = true;
						break
					case 'cancel':
						this.isCenceModal = true;
						break
					case 'query':
						this.isModalLayer = true;
						this.$api.navigateTo('/pages/user/order/order-logistics?orderID='+data.orderId)
						break
					case 'confirm':
						this.handOrderConfirm(data.orderId);
						break
				}
			},
			handOrderConfirm (id){//确认收货
				this.$api.get('/order/affirm',{orderID:id},
					response => {
						if(response.code === '1'){
							this.$util.msg(response.msg,2000,true,'success');
							this.isShowDelModal = false
							setTimeout(() => {
								this.getOrderDatainit(this.currentTab)
							},2000)
						}else{
							this.$util.msg(response.msg,2000);
						}
					}
				)
			},
			handOrderDetele (){//删除订单
				this.$api.get('/order/delete',{orderID:this.btnoRderID},
					response => {
						if(response.code === '1'){
							this.$util.msg(response.msg,2000,true,'success');
							this.isShowDelModal = false
							setTimeout(() => {
								this.orderData = [];
								this.getOrderDatainit(this.currentTab)
							},2000)
						}else{
							this.$util.msg(response.msg,2000);
						}
					}
				)
			},
			handCenceConfirm (){//取消订单
				this.$api.get('/order/cancel',{orderID:this.btnoRderID},
					response => {
						if(response.code === '1'){
							this.$util.msg(response.msg,2000,true,'success');
							this.isCenceModal = false
							setTimeout(() => {
								this.orderData = [];
								this.getOrderDatainit(this.currentTab)
							},2000)
						}else{
							this.$util.msg(response.msg,2000);
						}
					}
				)
			},
			onShareAppMessage (res){//分享转发
				this.isShareModal = false
				if (res.from === 'button') {// 来自页面内转发按钮
			    }
				return {
					title: '您有新的分享订单，快来查看吧~',
					path: `/pages/user/order/order-sharelogin?orderID=${this.btnoRderID}&userID=${this.userID}`,
					imageUrl:'https://img.caimei365.com/group1/M00/03/8C/Cmis215XHXSAWWkhAAXDP4-6m_c397.png'
				}
			},
			//订单状态文字和颜色
			orderStateExp (state){
				let stateText = '',
					stateTextObject={
						4:'交易完成',
						5:'订单完成',
						6:'已关闭',
						7:'交易全退',
						77:'交易全退',
						11:'待付款待发货',
						12:'待付款部分发货',
						13:'待付款已发货',
						21:'部分付款待发货',
						22:'部分付款部分发货',
						23:'部分付款已发货',
						31:'已付款待发货',
						32:'已付款部分发货',
						33:'已付款已发货',
						111:'待付款待发货',
					}
				Object.keys(stateTextObject).forEach(key => {
					if(key == state){
						stateText = stateTextObject[key]
					}
				})
				return stateText;
			},
			orderPriceToFixed (n){
				let price ='';
				price = n.toFixed(2);
				return price
			},
			getHeaderTopHeight (){ // 状态栏高度
				let statusBarHeight = this.systeminfo.statusBarHeight
				let headerPosi = this.headerBtnPosi
				let btnPosi = { // 胶囊实际位置，坐标信息不是左上角原点
				      height: headerPosi.height,
				      width: headerPosi.width,
				      // 胶囊top - 状态栏高度
				      top: headerPosi.top - statusBarHeight,
				      // 胶囊bottom - 胶囊height - 状态栏height （现胶囊bottom 为距离导航栏底部的长度）
				      bottom: headerPosi.bottom - headerPosi.height - statusBarHeight,
				      // 屏幕宽度 - 胶囊right
				      right: this.systeminfo.screenWidth - headerPosi.right
				}
				this.navbarHeight= headerPosi.bottom + btnPosi.bottom// 原胶囊bottom + 现胶囊bottom
			},
			setHeaderBtnPosi (){
				// 获得胶囊按钮位置信息
				let headerBtnPosi = uni.getMenuButtonBoundingClientRect();
				return headerBtnPosi
			},
			setSysteminfo (){
				let systeminfo;
				uni.getSystemInfo({ // 获取设备信息
					success: (res) => {
						systeminfo = res
					},
				})
				return systeminfo
			}
		},
		// onPullDownRefresh() {
		// 	if(!this.isEmpty){
		// 		setTimeout(() => {
		// 			this.pageNum = 1,
		// 			this.getOrderDatainit(this.currentTab)
		// 			uni.stopPullDownRefresh()				
		// 		}, 200);
		// 	}
		// },
		onReachBottom() {//上滑加载更多
			if(this.hasNextPage){
				this.loadding = true
				this.pullUpOn = true
				this.getOnReachBottomData(this.currentTab);
			}	
		},
		onPageScroll(e) {
			this.scrollTop = e.scrollTop;
		},
		onShow() {
			this.isModalLayer = false;	
			this.getOrderDatainit(this.currentTab)
		}
	}
</script>

<style lang="scss">
	page{
		background: #F7F7F7;
	}
	.container {
		padding-bottom: env(safe-area-inset-bottom);
		height: auto;
		position: relative;
	}
	.tui-order-content{
		width: 100%;
		height: auto;
	}
	.tui-order-list {
		margin-top: 80rpx;
		width: 100%;
		position: relative;
	}
	.tui-order-item {
		display: flex;
		flex-direction: column;
		width: 702rpx;
		padding:20rpx 24rpx 0 24rpx;
		background: #fff;
		border-bottom: 20rpx solid #F7F7F7;
	}
	.search-input{
		width: 100%;
		height: 80rpx;
		margin-bottom: 20rpx;
		.gosearch-btn{
			/* #ifndef APP-NVUE */
			display: flex;
			/* #endif */
			flex: 1;
			flex-direction: row;
			justify-content: center;
			align-items: center;
			width: 662rpx;
			height: 100%;
			border-radius: 40rpx;
			background: #F7F7F7;
			margin: 0 auto;
			padding:0 20rpx;
			font-size: 28rpx;
			line-height: 80rpx;
			color: #8A8A8A;
			.icon-iconfonticonfontsousuo1{
				margin:0 6rpx;
				font-size: 34rpx;
				color: #F29857;
				z-index: 10;
			}
		}
	}
	.order-title{
		width: 100%;
		height: auto;
		.order-title-t{
			width: 100%;
			height: 40rpx;
			float: left;
			font-size: $font-size-28;
			line-height: 40rpx;
			font-weight: bold;
			.order-title-num{
				float: left;
				text-align: left;
				color: $color-system;
			}
			.order-title-tip{
				float: right;
				text-align: right;
				color: #FF2A2A;
			}
		}
		.order-title-b{
			width: 100%;
			height: 40rpx;
			float: left;
			margin-top: 8rpx;
			font-size: $font-size-28;
			line-height: 40rpx;
			color: #999999;
			text-align: left;
		}
	}
	.goods-title{
		width: 100%;
		height: 48rpx;
		float: left;
		margin-top: 24rpx;
		.title-logo{
			width: 48rpx;
			height: 48rpx;
			float: left;
			image{
				width: 48rpx;
				height: 48rpx;
			}
		}
		.title-text{
			float: left;
			margin-left: 16rpx;
			font-size: $font-size-28;
			color: $text-color;
			text-align: left;
			line-height: 48rpx;
			font-weight: bold;
		}
	}
	.goods-item{
		width: 100%;
		height: auto;
	}	
	.goods-pros-t{
		display: flex;
		align-items: center;
		width: 100%;
		height: 217rpx;
		padding:24rpx 0;
		.pros-img{
			width: 210rpx;
			height: 100%;
			border-radius: 10rpx;
			margin:0 26rpx 0 0;
			border:1px solid #f3f3f3;
			image{
				width: 100%;
				height: 100%;
				border-radius: 10rpx;
			}
		}
	}
	.pros-product{
		width: 468rpx;
		height: 100%;
		line-height: 36rpx;
		font-size: $font-size-26;	
		position: relative;
		.producttitle{
			width: 100%;
			display: inline-block;
			height: auto;							
			text-overflow:ellipsis;
			display: -webkit-box;
			word-break: break-all;
			-webkit-box-orient: vertical;
			-webkit-line-clamp: 2;
			overflow: hidden;
			margin-bottom: 8rpx;
		}
		.productspec{
			height: 36rpx;
			color: #999999;
		}
		.productprice{
			height: 48rpx;
			position: absolute;
			width: 100%;
			bottom: 0;
			.price{
				line-height: 48rpx;
				font-size: $font-size-28;
				width: 48%;
				color: #FF2A2A;
				float: left;
				font-weight: bold;
			}
			.count{
				height: 100%;
				float: right;
				position: relative;
				.small{
					color: #666666;
				}
			}
		}
	}
	.order-footer{
		width: 100%;
		height: 78rpx;
		float: left;
		.order-footer-top{
			width: 100%;
			height: 34rpx;
			line-height: 34rpx;
			font-size: $font-size-24;
			color: #999999;
			text-align: right;
		}
		.order-footer-bot{
			width: 100%;
			float: left;
			height: 48rpx;
			line-height: 48rpx;
			font-size: $font-size-28;
			font-weight: bold;
			color: $text-color;
			.count{
				width: 50%;
				float: left;
				text-align: left;
			}
			.money{
				width: 50%;
				float: right;
				text-align: right;
			}
		}
	}
</style>
